; pwm_by_wizard_nov10.a51  8-bit ramping pwm, as in summer lab, but done with Wizard


; rev path 3/16
	$NOSYMBOLS	; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 

	STACKBOT EQU 07Fh	; put stack at start of scratch indirectly-addressable block (80h and up)

	; PWM output on P0.3

	ORG 0h

	LJMP STARTUP

	ORG 080h
				
STARTUP: MOV SP, #STACKBOT

	acall USUAL_SETUP
	acall Init_Device
	clr A
UP:		acall DELAY
	mov PCA0CPH0, A
	inc A
	sjmp UP


;------- SUBROUTINES --------
; long delay:
DELAY:  	PUSH ACC	; save registers that'll get messed up
					PUSH B

    	MOV A, #0				; get outer-loop delay value
INITINNER:	MOV B,#0			; initialize inner loop counter
INLOOP:	DJNZ B, INLOOP		; count down inner loop, till inner hits zero
			DJNZ ACC,INITINNER	; ...then dec outer, and start inner again.
			POP B  				
			POP ACC
			RET					; Now back to main program.

;------- INITIALIZATIONS

USUAL_SETUP: anl   PCA0MD, #NOT(040h)        ; Disable the WDT
	ret

;------------------------------------
;-  Generated Initialization File  --
;------------------------------------


; Peripheral specific initialization functions,
; Called from the Init_Device label
PCA_Init:
    mov  PCA0CN,    #040h
    mov  PCA0CPM0,  #042h
    ret

Port_IO_Init:
    ; P0.0  -  Skipped,     Open-Drain, Digital
    ; P0.1  -  Skipped,     Open-Drain, Digital
    ; P0.2  -  Skipped,     Open-Drain, Digital
    ; P0.3  -  CEX0 (PCA),  Push-Pull,  Digital

    mov  P0MDOUT,   #008h
    mov  P0SKIP,    #007h
    mov  XBR1,      #041h

    ; next line not from wizard: pushpull output

    mov P0MDOUT, #08h	; make PWM output, p0.3, push-pull rather than open-drain
    ret

; Initialization function for device,
; Call Init_Device from your main program
Init_Device:
    lcall PCA_Init
    lcall Port_IO_Init
    ret

end
